<!doctype html>

<html lang="en">
<head>
	<meta charset="utf-8">
	<title>Logiczzle Generator</title>
	<link rel="stylesheet" href="loading.css">
	<link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css" integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">

	<script src="http://epilog.stanford.edu/javascript/epilog.js"></script>
	<script src="http://worksheets.stanford.edu/javascript/worksheets.js"></script>
	<script src="https://code.jquery.com/jquery-3.4.1.min.js" integrity="sha256-CSXorXvZcTkaix6Yvo6HppcZGetbYMGWSFlBw8HfCJo=" crossorigin="anonymous"></script>
</head>
<body onload="initialize();">

<!--<button onclick="run();">run (test)</button>-->

<style>
.epilog-textarea {
	display: none;
}

#loading_container {
	width: 100%;
	height: 100%;
	background-color: #8c1515;
	position: fixed;
	display: flex;
	align-items: center;
}
.lds-grid {
	margin: 0 auto;
}

#puzzle_generating_indicator {
	display: none;
}


.puzzle-main {
	text-align: center;
}
.cell-cell, .cell-title {
	text-align: center;
}

.cell-select {
	width: 75px;
	height: 50px;
	font-size: 25px;
}

.clues-main {
	text-align: center;
	font-size: 25px;
	line-height: 0.76em;
}

.clue-span {
	margin-left: 10px;
}

#add_hint_button {
	font-size: 18px;
	padding: 10px;
}
</style>

<div id="loading_container">
	<div class="lds-grid"><div></div><div></div><div></div><div></div><div></div><div></div><div></div><div></div><div></div></div>
</div>

<span id="puzzle_generating_indicator">DEFAULT</span>

<div class="main">
	<!--=======================================================================-->
	<table class="table table-bordered">
		<thead>
		<tr>
			<th style="text-align: center">#</th>
			<?php for ($i = 1; $i <= $_GET["n"]; $i++) { ?>
			<th style="text-align: center"><?php echo $i; ?></th>
			<?php } ?>
		</tr>
		</thead>
		<tbody>
		<?php for ($i = 1; $i <= $_GET["m"]; $i++) { ?>
		<tr>
			<td class="cell-title" id="cell_title(<?php echo $i; ?>)">TITLE</td>
			<?php for ($j = 1; $j <= $_GET["n"]; $j++) { ?>
			<td class="cell-cell" id="cell_cell(<?php echo $i; ?>,<?php echo $j; ?>)">
				<select class="cell-select" id="picked(<?php echo $i; ?>,<?php echo $j; ?>)" onchange="modselector(this);">
					<?php for ($k = 0; $k <= $_GET["n"]; $k++) {
						$id = "canpick(".$i.",".$j.",".$k.")"; ?>
					<option id="<?php echo $id; ?>"><?php if ($k != 0) { echo $id; } ?></option>
					<?php } ?>
				</select>
			</td>
			<?php } ?>
		</tr>
		<?php } ?>
		</tbody>
	</table>

	<br>

	<div class="clues-main">
		<h1>Clues:</h1>
		<?php for ($i = 0; $i < 100; $i++) { ?>
		<p class="clue-line" id="clue_ui_line(<?php echo $i; ?>)"><input type="checkbox" id="clue_ui_checkbox(<?php echo $i; ?>)"><span class="clue-span" id="clue_ui_content(<?php echo $i; ?>)">clue_ui_content(<?php echo $i; ?>)</span></p>
		<?php } ?>
		<button onclick="modbutton(this);" id="add_hint_button" widget="button">Add Hint</button>
	</div>
</div>

<textarea class="epilog-textarea" id="lambda" type="text/hrf">
puzzle_size(<?php echo $_GET["m"]; ?>,<?php echo $_GET["n"]; ?>)
init_puzzle

<?php require_once("dataset.hrf"); ?>
</textarea>

<textarea class="epilog-textarea" id="library" type="text/hrf">
% -------- CORE --------
<?php require_once("ruleset.hrf"); ?>
<?php require_once("nl.hrf"); ?>

% -------- UI RELATED --------
<?php require_once("ui.hrf"); ?>
</textarea>


<script>
document.onload=run();

// `stop` after generation finished.
//More Details https://developer.mozilla.org/en-US/docs/Web/API/MutationObserver
// select the target node
var target = document.querySelector('#puzzle_generating_indicator')
// create an observer instance
var observer = new MutationObserver(function(mutations) {
	console.log($('#puzzle_generating_indicator').text());
	if ($('#puzzle_generating_indicator').text() === "not_generating") {
		// From http://worksheets.stanford.edu/javascript/worksheets.js
		if (ticker) {clearTimeout(ticker); ticker = false};
	}
});
// configuration of the observer:
var config = { childList: true};
// pass in the target node, as well as the observer options
observer.observe(target, config);
</script>

</body>
